/**
This class simulates a customer's use of an ATM.
The customer first inserts his or her card and logs in.
	The ATM now knows the customer's bank.
*/

public class Test {
	private Bank bank = new Bank();
	private Context context = new Context();

	public static void main(String[] args) {
		System.out.println("Begin test");
		Test t = new Test();
      	System.out.println("End test");
	}
	
	public Test () {
		// Initialize bank
		bank.addAccountNo (111, 1000);
		bank.addAccountNo (222, 0);
		System.out.println("Create and initialize accounts: Account #111 = $1000, #222 = $0");
		System.out.println("Transfer $300 from account #111 to #222");
		context.transfer (300, 111, 222, bank);
		// Check  result
		if ((bank.findAccountNo(111 ).balance() == 700) 
			&& (bank.findAccountNo(222).balance() == 300) ) {
			System.out.println (
				"Result of first transfer OK: "
				+ "#111 = " + bank.findAccountNo(111 ).balance().toString() 
				+ " #222 = " + bank.findAccountNo(222).balance().toString() );
		} else {
			System.out.println ("TestError:  First transfer result incorrect! " );
		};
		
		System.out.println("Try to transfer $500 from account #222 to #111");
		context.transfer (500, 222, 111, bank);
		// Check  result
		if ((bank.findAccountNo(111 ).balance() == 700) 
			&& (bank.findAccountNo(222).balance() == 300) ) {
			System.out.println (
				"Second transfer OK if it failed for insufficient funds. Accounts unchanged: "
				+ "#111 = " + bank.findAccountNo(111 ).balance().toString() 
				+ " #222. = " + bank.findAccountNo(222).balance().toString() );
		} else {
			System.out.println ("TestError: Second transfer result incorrect! " );
		};

	}
}